commit e0be8f2abff27c28b9c59b2836d00c07f0b6bbb9
Author: jklowden <jklowden>
Date:   Sun May 3 19:32:56 2009 +0000

    better ct-lib logging

diff --git a/BUGS b/BUGS
index 4c762a1..f454d77 100644
--- a/BUGS
+++ b/BUGS
@@ -15,7 +15,7 @@ Needs Fixing
    this requires either an SQL parser or API modification, 
    because the library has to determine the SQL datatype 
    of the placeholder variable.  
-6. ML Mar 19 2009: "Error in freebcp in", spurious error. 
+6. ML Mar 21 2009: "freebcp error HINT -b doesnt work", freebcp -n broken. 
 
 
 
diff --git a/ChangeLog b/ChangeLog
index c94f79d..ef05c21 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Sun May  3 15:26:26 EDT 2009	JK Lowden <jklowden@freetds.org>
+	* src/ctlib/blk.c src/ctlib/cs.c src/ctlib/ct.c
+	* src/ctlib/ctutil.c src/ctlib/unittests/common.c
+	* src/dblib/dbutil.c BUGS
+	- better ct-lib logging
+
 Thu Apr 30 08:48:24 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* misc/check_symbols.txt misc/order_coverage.pl: notes and updates
 
@@ -1522,4 +1528,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2781 2009/04/30 06:48:49 freddy77 Exp $
+$Id: ChangeLog,v 1.2782 2009/05/03 19:32:56 jklowden Exp $
diff --git a/src/ctlib/blk.c b/src/ctlib/blk.c
index 7d0a25b..d0eb7d9 100644
--- a/src/ctlib/blk.c
+++ b/src/ctlib/blk.c
@@ -38,7 +38,7 @@
 #include "ctlib.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: blk.c,v 1.49 2008/12/19 10:37:51 freddy77 Exp $");
+TDS_RCSID(var, "$Id: blk.c,v 1.50 2009/05/03 19:32:57 jklowden Exp $");
 
 static void _blk_null_error(TDSBCPINFO *bcpinfo, int index, int offset);
 static int _blk_get_col_data(TDSBCPINFO *bulk, TDSCOLUMN *bcpcol, int offset);
@@ -48,7 +48,7 @@ static CS_RETCODE _blk_rowxfer_out(CS_BLKDESC * blkdesc, CS_INT rows_to_xfer, CS
 CS_RETCODE
 blk_alloc(CS_CONNECTION * connection, CS_INT version, CS_BLKDESC ** blk_pointer)
 {
-	tdsdump_log(TDS_DBG_FUNC, "blk_alloc()\n");
+	tdsdump_log(TDS_DBG_FUNC, "blk_alloc(%p, %d, %p)\n", connection, version, blk_pointer);
 
 	*blk_pointer = (CS_BLKDESC *) malloc(sizeof(CS_BLKDESC));
 	memset(*blk_pointer, '\0', sizeof(CS_BLKDESC));
@@ -68,7 +68,7 @@ blk_bind(CS_BLKDESC * blkdesc, CS_INT item, CS_DATAFMT * datafmt, CS_VOID * buff
 	CS_INT bind_count;
 	int i;
 
-	tdsdump_log(TDS_DBG_FUNC, "blk_bind()\n");
+	tdsdump_log(TDS_DBG_FUNC, "blk_bind(%p, %d, %p, %p, %p, %p)\n", blkdesc, item, datafmt, buffer, datalen, indicator);
 
 	if (!blkdesc) {
 		return CS_FAIL;
@@ -155,6 +155,9 @@ blk_colval(SRV_PROC * srvproc, CS_BLKDESC * blkdescp, CS_BLK_ROW * rowp, CS_INT
 	   CS_INT * outlenp)
 {
 
+	tdsdump_log(TDS_DBG_FUNC, "blk_colval(%p, %p, %p, %d, %p, %d, %p)\n", 
+				srvproc, blkdescp, rowp, colnum, valuep, valuelen, outlenp);
+
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED blk_colval()\n");
 	return CS_FAIL;
 }
@@ -163,6 +166,8 @@ CS_RETCODE
 blk_default(CS_BLKDESC * blkdesc, CS_INT colnum, CS_VOID * buffer, CS_INT buflen, CS_INT * outlen)
 {
 
+	tdsdump_log(TDS_DBG_FUNC, "blk_default(%p, %d, %p, %d, %p)\n", blkdesc, colnum, buffer, buflen, outlen);
+
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED blk_default()\n");
 	return CS_FAIL;
 }
@@ -173,7 +178,7 @@ blk_describe(CS_BLKDESC * blkdesc, CS_INT item, CS_DATAFMT * datafmt)
 	TDSCOLUMN *curcol;
 	int len;
 
-	tdsdump_log(TDS_DBG_FUNC, "blk_describe()\n");
+	tdsdump_log(TDS_DBG_FUNC, "blk_describe(%p, %d, %p)\n", blkdesc, item, datafmt);
 
 	if (item < 1 || item > blkdesc->bcpinfo.bindinfo->num_cols) {
 		_ctclient_msg(blkdesc->con, "blk_describe", 2, 5, 1, 141, "%s, %d", "colnum", item);
@@ -220,7 +225,8 @@ blk_done(CS_BLKDESC * blkdesc, CS_INT type, CS_INT * outrow)
 	TDSSOCKET *tds;
 	int rows_copied;
 
-	tdsdump_log(TDS_DBG_FUNC, "blk_done()\n");
+	tdsdump_log(TDS_DBG_FUNC, "blk_done(%p, %d, %p)\n", blkdesc, type, outrow);
+
 	tds = blkdesc->con->tds_socket;
 
 	switch (type) {
@@ -276,6 +282,8 @@ blk_done(CS_BLKDESC * blkdesc, CS_INT type, CS_INT * outrow)
 CS_RETCODE
 blk_drop(CS_BLKDESC * blkdesc)
 {
+	tdsdump_log(TDS_DBG_FUNC, "blk_drop(%p)\n", blkdesc);
+
 	if (!blkdesc)
 		return CS_SUCCEED;
 
@@ -290,6 +298,7 @@ blk_drop(CS_BLKDESC * blkdesc)
 CS_RETCODE
 blk_getrow(SRV_PROC * srvproc, CS_BLKDESC * blkdescp, CS_BLK_ROW * rowp)
 {
+	tdsdump_log(TDS_DBG_FUNC, "blk_getrow(%p, %p, %p)\n", srvproc, blkdescp, rowp);
 
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED blk_getrow()\n");
 	return CS_FAIL;
@@ -299,6 +308,8 @@ CS_RETCODE
 blk_gettext(SRV_PROC * srvproc, CS_BLKDESC * blkdescp, CS_BLK_ROW * rowp, CS_INT bufsize, CS_INT * outlenp)
 {
 
+	tdsdump_log(TDS_DBG_FUNC, "blk_gettext(%p, %p, %p, %d, %p)\n", srvproc, blkdescp, rowp, bufsize, outlenp);
+
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED blk_gettext()\n");
 	return CS_FAIL;
 }
@@ -306,7 +317,7 @@ blk_gettext(SRV_PROC * srvproc, CS_BLKDESC * blkdescp, CS_BLK_ROW * rowp, CS_INT
 CS_RETCODE
 blk_init(CS_BLKDESC * blkdesc, CS_INT direction, CS_CHAR * tablename, CS_INT tnamelen)
 {
-	tdsdump_log(TDS_DBG_FUNC, "blk_init()\n");
+	tdsdump_log(TDS_DBG_FUNC, "blk_init(%p, %d, %p, %d)\n", blkdesc, direction, tablename, tnamelen);
 
 	if (!blkdesc) {
 		return CS_FAIL;
@@ -365,9 +376,9 @@ blk_init(CS_BLKDESC * blkdesc, CS_INT direction, CS_CHAR * tablename, CS_INT tna
 CS_RETCODE
 blk_props(CS_BLKDESC * blkdesc, CS_INT action, CS_INT property, CS_VOID * buffer, CS_INT buflen, CS_INT * outlen)
 {
+	int retval, intval;
 
-	int retval;
-	int intval;
+	tdsdump_log(TDS_DBG_FUNC, "blk_props(%p, %d, %d, %p, %d, %p)\n", blkdesc, action, property, buffer, buflen, outlen);
 
 	switch (property) {
 	case BLK_IDENTITY: 
@@ -407,6 +418,7 @@ blk_props(CS_BLKDESC * blkdesc, CS_INT action, CS_INT property, CS_VOID * buffer
 CS_RETCODE
 blk_rowalloc(SRV_PROC * srvproc, CS_BLK_ROW ** row)
 {
+	tdsdump_log(TDS_DBG_FUNC, "blk_rowalloc(%p, %p)\n", srvproc, row);
 
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED blk_rowalloc()\n");
 	return CS_FAIL;
@@ -415,6 +427,7 @@ blk_rowalloc(SRV_PROC * srvproc, CS_BLK_ROW ** row)
 CS_RETCODE
 blk_rowdrop(SRV_PROC * srvproc, CS_BLK_ROW * row)
 {
+	tdsdump_log(TDS_DBG_FUNC, "blk_rowdrop(%p, %p)\n", srvproc, row);
 
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED blk_rowdrop()\n");
 	return CS_FAIL;
@@ -425,6 +438,8 @@ blk_rowxfer(CS_BLKDESC * blkdesc)
 {
 	CS_INT row_count = 1;
 
+	tdsdump_log(TDS_DBG_FUNC, "blk_rowxfer(%p)\n", blkdesc);
+
 	return blk_rowxfer_mult(blkdesc, &row_count);
 }
 
@@ -435,7 +450,7 @@ blk_rowxfer_mult(CS_BLKDESC * blkdesc, CS_INT * row_count)
 	CS_INT rows_xferred = 0;
 	CS_RETCODE ret;
 
-	tdsdump_log(TDS_DBG_FUNC, "blk_rowxfer_mult()\n");
+	tdsdump_log(TDS_DBG_FUNC, "blk_rowxfer_mult(%p, %p)\n", blkdesc, row_count);
 
 	if (!row_count || *row_count == 0 )
 		rows_to_xfer = blkdesc->bcpinfo.bind_count;
@@ -457,6 +472,8 @@ CS_RETCODE
 blk_sendrow(CS_BLKDESC * blkdesc, CS_BLK_ROW * row)
 {
 
+	tdsdump_log(TDS_DBG_FUNC, "blk_sendrow(%p, %p)\n", blkdesc, row);
+
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED blk_sendrow()\n");
 	return CS_FAIL;
 }
@@ -464,6 +481,7 @@ blk_sendrow(CS_BLKDESC * blkdesc, CS_BLK_ROW * row)
 CS_RETCODE
 blk_sendtext(CS_BLKDESC * blkdesc, CS_BLK_ROW * row, CS_BYTE * buffer, CS_INT buflen)
 {
+	tdsdump_log(TDS_DBG_FUNC, "blk_sendtext(%p, %p, %p, %d)\n", blkdesc, row, buffer, buflen);
 
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED blk_sendtext()\n");
 	return CS_FAIL;
@@ -472,6 +490,7 @@ blk_sendtext(CS_BLKDESC * blkdesc, CS_BLK_ROW * row, CS_BYTE * buffer, CS_INT bu
 CS_RETCODE
 blk_srvinit(SRV_PROC * srvproc, CS_BLKDESC * blkdescp)
 {
+	tdsdump_log(TDS_DBG_FUNC, "blk_srvinit(%p, %p)\n", srvproc, blkdescp);
 
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED blk_srvinit()\n");
 	return CS_FAIL;
@@ -480,6 +499,7 @@ blk_srvinit(SRV_PROC * srvproc, CS_BLKDESC * blkdescp)
 CS_RETCODE
 blk_textxfer(CS_BLKDESC * blkdesc, CS_BYTE * buffer, CS_INT buflen, CS_INT * outlen)
 {
+	tdsdump_log(TDS_DBG_FUNC, "blk_textxfer(%p, %p, %d, %p)\n", blkdesc, buffer, buflen, outlen);
 
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED blk_textxfer()\n");
 	return CS_FAIL;
@@ -488,7 +508,6 @@ blk_textxfer(CS_BLKDESC * blkdesc, CS_BYTE * buffer, CS_INT buflen, CS_INT * out
 static CS_RETCODE
 _blk_rowxfer_out(CS_BLKDESC * blkdesc, CS_INT rows_to_xfer, CS_INT * rows_xferred)
 {
-
 	TDSSOCKET *tds;
 	TDS_INT result_type;
 	TDS_INT ret;
@@ -496,7 +515,7 @@ _blk_rowxfer_out(CS_BLKDESC * blkdesc, CS_INT rows_to_xfer, CS_INT * rows_xferre
 	TDS_INT row_of_query;
 	TDS_INT rows_written;
 
-	tdsdump_log(TDS_DBG_FUNC, "blk_rowxfer_out()\n");
+	tdsdump_log(TDS_DBG_FUNC, "_blk_rowxfer_out(%p, %d, %p)\n", blkdesc, rows_to_xfer, rows_xferred);
 
 	if (!blkdesc || !blkdesc->con)
 		return CS_FAIL;
@@ -569,10 +588,11 @@ _blk_rowxfer_out(CS_BLKDESC * blkdesc, CS_INT rows_to_xfer, CS_INT * rows_xferre
 static CS_RETCODE
 _blk_rowxfer_in(CS_BLKDESC * blkdesc, CS_INT rows_to_xfer, CS_INT * rows_xferred)
 {
-
 	TDSSOCKET *tds;
 	TDS_INT each_row;
 
+	tdsdump_log(TDS_DBG_FUNC, "_blk_rowxfer_in(%p, %d, %p)\n", blkdesc, rows_to_xfer, rows_xferred);
+
 	if (!blkdesc)
 		return CS_FAIL;
 
@@ -613,6 +633,9 @@ static void
 _blk_null_error(TDSBCPINFO *bcpinfo, int index, int offset)
 {
 	CS_BLKDESC *blkdesc = (CS_BLKDESC *) bcpinfo->parent;
+
+	tdsdump_log(TDS_DBG_FUNC, "_blk_null_error(%p, %d, %d)\n", bcpinfo, index, offset);
+
 	_ctclient_msg(blkdesc->con, "blk_rowxfer", 2, 7, 1, 142, "%d, %d",  index + 1, offset + 1);
 }
 
@@ -620,9 +643,7 @@ static int
 _blk_get_col_data(TDSBCPINFO *bulk, TDSCOLUMN *bindcol, int offset)
 {
 	int result = 0;
-
 	CS_INT null_column = 0;
-	
 	unsigned char *src = NULL;
 
 	CS_INT      srctype = 0;
@@ -634,13 +655,13 @@ _blk_get_col_data(TDSBCPINFO *bulk, TDSCOLUMN *bindcol, int offset)
 	CS_CONTEXT *ctx = blkdesc->con->ctx;
 	CS_DATAFMT srcfmt, destfmt;
 
+	tdsdump_log(TDS_DBG_FUNC, "_blk_get_col_data(%p, %p, %d)\n", bulk, bindcol, offset);
+
 	/*
-	 * retrieve the initial bound column_varaddress
+	 * Retrieve the initial bound column_varaddress
 	 * and increment it if offset specified
 	 */
 
-	tdsdump_log(TDS_DBG_FUNC, "_blk_get_col_data(%p, %p, %d)\n", bulk, bindcol, offset);
-
 	src = (unsigned char *) bindcol->column_varaddr;
 	src += offset * bindcol->column_bindlen;
 	
@@ -654,8 +675,7 @@ _blk_get_col_data(TDSBCPINFO *bulk, TDSCOLUMN *bindcol, int offset)
 	}
 
 	if (src) {
-	
-		srctype = bindcol->column_bindtype; 		/* used to pass to cs_convert */
+		srctype = bindcol->column_bindtype; 		/* passes to cs_convert */
 
 		tdsdump_log(TDS_DBG_INFO1, "blk_get_col_data srctype = %d \n", srctype);
 		tdsdump_log(TDS_DBG_INFO1, "blk_get_col_data datalen = %d \n", *datalen);
diff --git a/src/ctlib/cs.c b/src/ctlib/cs.c
index fd99aae..3646016 100644
--- a/src/ctlib/cs.c
+++ b/src/ctlib/cs.c
@@ -50,7 +50,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: cs.c,v 1.69 2008/12/10 14:56:26 freddy77 Exp $");
+TDS_RCSID(var, "$Id: cs.c,v 1.70 2009/05/03 19:32:57 jklowden Exp $");
 
 static int _cs_datatype_length(int dtype);
 static CS_INT cs_diag_storemsg(CS_CONTEXT *context, CS_CLIENTMSG *message);
@@ -63,6 +63,8 @@ cs_prretcode(int retcode)
 {
 	static char unknown[24];
 	
+	tdsdump_log(TDS_DBG_FUNC, "cs_prretcode(%d)\n", retcode);
+
 	switch(retcode) {
 	case CS_SUCCEED:	return "CS_SUCCEED";
 	case CS_FAIL:		return "CS_FAIL";
@@ -98,6 +100,8 @@ cs_prretcode(int retcode)
 static int 
 _cs_datatype_length(int dtype)
 {
+	tdsdump_log(TDS_DBG_FUNC, "_cs_datatype_length(%d)\n", dtype);
+
 	switch (dtype) {
 		case SYBINT1:
 			return 1;
@@ -129,6 +133,8 @@ _cs_datatype_length(int dtype)
 static const char *
 _cs_get_layer(int layer)
 {
+	tdsdump_log(TDS_DBG_FUNC, "_cs_get_layer(%d)\n", layer);
+
 	switch (layer) {
 	case 2:
 		return "cslib user api layer";
@@ -142,6 +148,8 @@ _cs_get_layer(int layer)
 static const char *
 _cs_get_origin(int origin)
 {
+	tdsdump_log(TDS_DBG_FUNC, "_cs_get_origin(%d)\n", origin);
+
 	switch (origin) {
 	case 1:
 		return "external error";
@@ -164,6 +172,8 @@ _cs_get_origin(int origin)
 static const char *
 _cs_get_user_api_layer_error(int error)
 {
+	tdsdump_log(TDS_DBG_FUNC, "_cs_get_user_api_layer_error(%d)\n", error);
+
 	switch (error) {
 	case 3:
 		return "Memory allocation failure.";
@@ -188,6 +198,8 @@ _cs_get_msgstr(const char *funcname, int layer, int origin, int severity, int nu
 {
 	char *m;
 
+	tdsdump_log(TDS_DBG_FUNC, "_cs_get_msgstr(%s, %d, %d, %d, %d)\n", funcname, layer, origin, severity, number);
+
 	if (asprintf(&m, "%s: %s: %s: %s", funcname, _cs_get_layer(layer), _cs_get_origin(origin), (layer == 2)
 		     ? _cs_get_user_api_layer_error(number)
 		     : "unrecognized error") < 0) {
@@ -203,6 +215,8 @@ _csclient_msg(CS_CONTEXT * ctx, const char *funcname, int layer, int origin, int
 	CS_CLIENTMSG cm;
 	char *msgstr;
 
+	tdsdump_log(TDS_DBG_FUNC, "_csclient_msg(%p, %s, %d, %d, %d, %d, %s)\n", ctx, funcname, layer, origin, severity, number, fmt);
+
 	va_start(ap, fmt);
 
 	if (ctx->_cslibmsg_cb) {
@@ -234,12 +248,16 @@ _csclient_msg(CS_CONTEXT * ctx, const char *funcname, int layer, int origin, int
 static CS_LOCALE *
 _cs_locale_alloc(void)
 {
+	tdsdump_log(TDS_DBG_FUNC, "_cs_locale_alloc()\n");
+
 	return (CS_LOCALE *) calloc(1, sizeof(CS_LOCALE));
 }
 
 static void
 _cs_locale_free_contents(CS_LOCALE *locale)
 {
+	tdsdump_log(TDS_DBG_FUNC, "_cs_locale_free_contents(%p)\n", locale);
+
 	/* free strings */
 	free(locale->language);
 	locale->language = NULL;
@@ -254,6 +272,8 @@ _cs_locale_free_contents(CS_LOCALE *locale)
 void 
 _cs_locale_free(CS_LOCALE *locale)
 {
+	tdsdump_log(TDS_DBG_FUNC, "_cs_locale_free(%p)\n", locale);
+
 	/* free contents */
 	_cs_locale_free_contents(locale);
 
@@ -265,6 +285,8 @@ _cs_locale_free(CS_LOCALE *locale)
 int
 _cs_locale_copy_inplace(CS_LOCALE *new_locale, CS_LOCALE *orig)
 {
+	tdsdump_log(TDS_DBG_FUNC, "_cs_locale_copy_inplace(%p, %p)\n", new_locale, orig);
+
 	_cs_locale_free_contents(new_locale);
 	if (orig->language) {
 		new_locale->language = strdup(orig->language);
@@ -303,6 +325,8 @@ _cs_locale_copy(CS_LOCALE *orig)
 {
 	CS_LOCALE *new_locale;
 
+	tdsdump_log(TDS_DBG_FUNC, "_cs_locale_copy(%p)\n", orig);
+
 	new_locale = _cs_locale_alloc();
 	if (!new_locale)
 		return NULL;
@@ -341,7 +365,9 @@ Cleanup:
 CS_RETCODE
 cs_ctx_alloc(CS_INT version, CS_CONTEXT ** ctx)
 {
-TDSCONTEXT *tds_ctx;
+	TDSCONTEXT *tds_ctx;
+
+	tdsdump_log(TDS_DBG_FUNC, "cs_ctx_alloc(%d, %p)\n", version, ctx);
 
 	*ctx = (CS_CONTEXT *) malloc(sizeof(CS_CONTEXT));
 	memset(*ctx, '\0', sizeof(CS_CONTEXT));
@@ -361,7 +387,9 @@ TDSCONTEXT *tds_ctx;
 CS_RETCODE
 cs_ctx_global(CS_INT version, CS_CONTEXT ** ctx)
 {
-static CS_CONTEXT *global_cs_ctx = NULL;
+	static CS_CONTEXT *global_cs_ctx = NULL;
+
+	tdsdump_log(TDS_DBG_FUNC, "cs_ctx_global(%d, %p)\n", version, ctx);
 
 	if (global_cs_ctx != NULL) {
 		*ctx = global_cs_ctx;
@@ -377,6 +405,8 @@ static CS_CONTEXT *global_cs_ctx = NULL;
 CS_RETCODE
 cs_ctx_drop(CS_CONTEXT * ctx)
 {
+	tdsdump_log(TDS_DBG_FUNC, "cs_ctx_drop(%p)\n", ctx);
+
 	if (ctx) {
 		_ct_diag_clearmsg(ctx, CS_ALLMSG_TYPE);
 		free(ctx->userdata);
@@ -390,8 +420,9 @@ cs_ctx_drop(CS_CONTEXT * ctx)
 CS_RETCODE
 cs_config(CS_CONTEXT * ctx, CS_INT action, CS_INT property, CS_VOID * buffer, CS_INT buflen, CS_INT * outlen)
 {
-/* declared  for - CS_USERDATA changes - swapna*/
-CS_INT maxcp;
+	CS_INT maxcp;	/* declared  for - CS_USERDATA changes - swapna*/
+
+	tdsdump_log(TDS_DBG_FUNC, "cs_config(%p, %d, %d, %p, %d, %p)\n", ctx, action, property, buffer, buflen, outlen);
 
 	if (action == CS_GET) {
 		if (buffer == NULL) {
@@ -483,7 +514,6 @@ CS_INT maxcp;
 CS_RETCODE
 cs_convert(CS_CONTEXT * ctx, CS_DATAFMT * srcfmt, CS_VOID * srcdata, CS_DATAFMT * destfmt, CS_VOID * destdata, CS_INT * resultlen)
 {
-
 	int src_type, src_len, desttype, destlen, len, i = 0;
 	CONV_RESULT cres;
 	unsigned char *dest;
@@ -849,6 +879,8 @@ cs_dt_crack(CS_CONTEXT * ctx, CS_INT datetype, CS_VOID * dateval, CS_DATEREC * d
 	TDS_DATETIME4 *dt4;
 	TDSDATEREC dr;
 
+	tdsdump_log(TDS_DBG_FUNC, "cs_dt_crack(%p, %d, %p, %p)\n", ctx, datetype, dateval, daterec);
+
 	if (datetype == CS_DATETIME_TYPE) {
 		dt = (TDS_DATETIME *) dateval;
 		tds_datecrack(SYBDATETIME, dt, &dr);
@@ -877,6 +909,8 @@ cs_loc_alloc(CS_CONTEXT * ctx, CS_LOCALE ** locptr)
 {
 	CS_LOCALE *tds_csloc;
 
+	tdsdump_log(TDS_DBG_FUNC, "cs_loc_alloc(%p, %p)\n", ctx, locptr);
+
 	tds_csloc = _cs_locale_alloc();
 	if (!tds_csloc)
 		return CS_FAIL;
@@ -888,6 +922,8 @@ cs_loc_alloc(CS_CONTEXT * ctx, CS_LOCALE ** locptr)
 CS_RETCODE
 cs_loc_drop(CS_CONTEXT * ctx, CS_LOCALE * locale)
 {
+	tdsdump_log(TDS_DBG_FUNC, "cs_loc_drop(%p, %p)\n", ctx, locale);
+
 	if (!locale)
 		return CS_FAIL;
 
@@ -900,6 +936,8 @@ cs_locale(CS_CONTEXT * ctx, CS_INT action, CS_LOCALE * locale, CS_INT type, CS_V
 {
 	CS_RETCODE code = CS_FAIL;
 
+	tdsdump_log(TDS_DBG_FUNC, "cs_locale(%p, %d, %p, %d, %p, %d, %p)\n", ctx, action, locale, type, buffer, buflen, outlen);
+
 	if (action == CS_SET) {
 		switch (type) {
 		case CS_LC_ALL:
@@ -1082,6 +1120,9 @@ CS_RETCODE
 cs_dt_info(CS_CONTEXT * ctx, CS_INT action, CS_LOCALE * locale, CS_INT type, CS_INT item, CS_VOID * buffer, CS_INT buflen,
 	   CS_INT * outlen)
 {
+	tdsdump_log(TDS_DBG_FUNC, "cs_dt_info(%p, %d, %p, %d, %d, %p, %d, %p)\n", 
+				ctx, action, locale, type, item, buffer, buflen, outlen);
+
 	if (action == CS_SET) {
 		switch (type) {
 		case CS_DT_CONVFMT:
@@ -1098,6 +1139,9 @@ cs_strbuild(CS_CONTEXT * ctx, CS_CHAR * buffer, CS_INT buflen, CS_INT * resultle
 	va_list ap;
 	CS_RETCODE rc;
 
+	tdsdump_log(TDS_DBG_FUNC, "cs_strbuild(%p, %p, %d, %p, %p, %d, %p, %d)\n", 
+				ctx, buffer, buflen, resultlen, text, textlen, formats, formatlen);
+
 	va_start(ap, formatlen);
 	rc = tds_vstrbuild(buffer, buflen, resultlen, text, textlen, formats, formatlen, ap);
 	va_end(ap);
@@ -1108,6 +1152,8 @@ CS_RETCODE
 cs_calc(CS_CONTEXT * ctx, CS_INT op, CS_INT datatype, CS_VOID * var1, CS_VOID * var2, CS_VOID * dest)
 {
 
+	tdsdump_log(TDS_DBG_FUNC, "cs_calc(%p, %d, %d, %p, %p, %p)\n", ctx, op, datatype, var1, var2, dest);
+
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED cs_calc()\n");
 	return CS_FAIL;
 }
@@ -1116,6 +1162,8 @@ CS_RETCODE
 cs_cmp(CS_CONTEXT * ctx, CS_INT datatype, CS_VOID * var1, CS_VOID * var2, CS_INT * result)
 {
 
+	tdsdump_log(TDS_DBG_FUNC, "cs_cmp(%p, %d, %p, %p, %p)\n", ctx, datatype, var1, var2, result);
+
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED cs_cmp()\n");
 	return CS_FAIL;
 }
@@ -1124,6 +1172,8 @@ CS_RETCODE
 cs_conv_mult(CS_CONTEXT * ctx, CS_LOCALE * srcloc, CS_LOCALE * destloc, CS_INT * conv_multiplier)
 {
 
+	tdsdump_log(TDS_DBG_FUNC, "cs_conv_mult(%p, %p, %p, %p)\n", ctx, srcloc, destloc, conv_multiplier);
+
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED cs_conv_mult()\n");
 	return CS_FAIL;
 }
@@ -1131,6 +1181,8 @@ cs_conv_mult(CS_CONTEXT * ctx, CS_LOCALE * srcloc, CS_LOCALE * destloc, CS_INT *
 CS_RETCODE
 cs_diag(CS_CONTEXT * ctx, CS_INT operation, CS_INT type, CS_INT idx, CS_VOID * buffer)
 {
+	tdsdump_log(TDS_DBG_FUNC, "cs_diag(%p, %d, %d, %d, %p)\n", ctx, operation, type, idx, buffer);
+
 	switch (operation) {
 
 		case CS_INIT:
@@ -1189,6 +1241,9 @@ cs_manage_convert(CS_CONTEXT * ctx, CS_INT action, CS_INT srctype, CS_CHAR * src
 		  CS_CHAR * destname, CS_INT destnamelen, CS_INT * conv_multiplier, CS_CONV_FUNC * func)
 {
 
+	tdsdump_log(TDS_DBG_FUNC, "cs_manage_convert(%p, %d, %d, %p, %d, %d, %p, %d, %p, %p)\n", 
+				ctx, action, srctype, srcname, srcnamelen, desttype, destname, destnamelen, conv_multiplier, func);
+
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED cs_manage_convert()\n");
 	return CS_FAIL;
 }
@@ -1197,6 +1252,8 @@ CS_RETCODE
 cs_objects(CS_CONTEXT * ctx, CS_INT action, CS_OBJNAME * objname, CS_OBJDATA * objdata)
 {
 
+	tdsdump_log(TDS_DBG_FUNC, "cs_objects(%p, %d, %p, %p)\n", ctx, action, objname, objdata);
+
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED cs_objects()\n");
 	return CS_FAIL;
 }
@@ -1205,6 +1262,8 @@ CS_RETCODE
 cs_set_convert(CS_CONTEXT * ctx, CS_INT action, CS_INT srctype, CS_INT desttype, CS_CONV_FUNC * func)
 {
 
+	tdsdump_log(TDS_DBG_FUNC, "cs_set_convert(%p, %d, %d, %d, %p)\n", ctx, action, srctype, desttype, func);
+
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED cs_set_convert()\n");
 	return CS_FAIL;
 }
@@ -1213,6 +1272,8 @@ CS_RETCODE
 cs_setnull(CS_CONTEXT * ctx, CS_DATAFMT * datafmt, CS_VOID * buffer, CS_INT buflen)
 {
 
+	tdsdump_log(TDS_DBG_FUNC, "cs_setnull(%p, %p, %p, %d)\n", ctx, datafmt, buffer, buflen);
+
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED cs_setnull()\n");
 	return CS_FAIL;
 }
@@ -1222,6 +1283,9 @@ cs_strcmp(CS_CONTEXT * ctx, CS_LOCALE * locale, CS_INT type, CS_CHAR * str1, CS_
 	  CS_INT * result)
 {
 
+	tdsdump_log(TDS_DBG_FUNC, "cs_strcmp(%p, %p, %d, %p, %d, %p, %d, %p)\n", 
+					ctx, locale, type, str1, len1, str2, len2, result);
+
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED cs_strcmp()\n");
 	return CS_FAIL;
 }
@@ -1230,6 +1294,8 @@ CS_RETCODE
 cs_time(CS_CONTEXT * ctx, CS_LOCALE * locale, CS_VOID * buffer, CS_INT buflen, CS_INT * outlen, CS_DATEREC * daterec)
 {
 
+	tdsdump_log(TDS_DBG_FUNC, "cs_time(%p, %p, %p, %d, %p, %p)\n", ctx, locale, buffer, buflen, outlen, daterec);
+
 	tdsdump_log(TDS_DBG_FUNC, "UNIMPLEMENTED cs_time()\n");
 	return CS_FAIL;
 }
@@ -1238,6 +1304,8 @@ CS_RETCODE
 cs_will_convert(CS_CONTEXT * ctx, CS_INT srctype, CS_INT desttype, CS_BOOL * result)
 {
 
+	tdsdump_log(TDS_DBG_FUNC, "cs_will_convert(%p, %d, %d, %p)\n", ctx, srctype, desttype, result);
+
 	*result = (tds_willconvert(srctype, desttype) ? CS_TRUE : CS_FALSE);
 	return CS_SUCCEED;
 }
@@ -1245,9 +1313,10 @@ cs_will_convert(CS_CONTEXT * ctx, CS_INT srctype, CS_INT desttype, CS_BOOL * res
 static CS_INT 
 cs_diag_storemsg(CS_CONTEXT *context, CS_CLIENTMSG *message)
 {
+	struct cs_diag_msg **curptr;
+	CS_INT msg_count = 0;
 
-struct cs_diag_msg **curptr;
-CS_INT msg_count = 0;
+	tdsdump_log(TDS_DBG_FUNC, "cs_diag_storemsg(%p, %p)\n", context, message);
 
 	curptr = &(context->msgstore);
 
@@ -1286,9 +1355,10 @@ CS_INT msg_count = 0;
 static CS_INT 
 cs_diag_getmsg(CS_CONTEXT *context, CS_INT idx, CS_CLIENTMSG *message)
 {
+	struct cs_diag_msg *curptr;
+	CS_INT msg_count = 0, msg_found = 0;
 
-struct cs_diag_msg *curptr;
-CS_INT msg_count = 0, msg_found = 0;
+	tdsdump_log(TDS_DBG_FUNC, "cs_diag_getmsg(%p, %d, %p)\n", context, idx, message);
 
 	curptr = context->msgstore;
 
@@ -1314,8 +1384,9 @@ CS_INT msg_count = 0, msg_found = 0;
 static CS_INT 
 cs_diag_clearmsg(CS_CONTEXT *context, CS_INT type)
 {
+	struct cs_diag_msg *curptr, *freeptr;
 
-struct cs_diag_msg *curptr, *freeptr;
+	tdsdump_log(TDS_DBG_FUNC, "cs_diag_clearmsg(%p, %d)\n", context, type);
 
 	curptr = context->msgstore;
 	context->msgstore = NULL;
@@ -1332,8 +1403,10 @@ struct cs_diag_msg *curptr, *freeptr;
 static CS_INT 
 cs_diag_countmsg(CS_CONTEXT *context, CS_INT *count)
 {
-struct cs_diag_msg *curptr;
-CS_INT msg_count = 0;
+	struct cs_diag_msg *curptr;
+	CS_INT msg_count = 0;
+
+	tdsdump_log(TDS_DBG_FUNC, "cs_diag_countmsg(%p, %p)\n", context, count);
 
 	curptr = context->msgstore;
 
